with Gtk.Window; use Gtk.Window;
with Gtk.Fixed; use Gtk.Fixed;
with Gtk.Frame; use Gtk.Frame;
with Gtk.Label; use Gtk.Label;
with Gtk.Box; use Gtk.Box;
with Gtk.Pixmap; use Gtk.Pixmap;
with Gtk.Adjustment; use Gtk.Adjustment;
with Gtk.Spin_Button; use Gtk.Spin_Button;
with Gtk.Button; use Gtk.Button;
with Gtk.Accel_Group; use Gtk.Accel_Group;
with Gdk.Types.Keysyms; use Gdk.Types.Keysyms;

--  with Transactional_Auctions; use Transactional_Auctions;
--  with Command_Buffers; use Command_Buffers;
--  with Auction_Interface; use Auction_Interface;
with Remote_String_Arrays; use Remote_String_Arrays;
with User_Interface; use User_Interface;
with Gtk.Main; use Gtk.Main;

package Bid_Window_Pkg is

   type Bid_Win_Status_Type is
      (Bidding, Currently_Highest, Finished);

   type Bid_Window_Record is new Gtk_Window_Record with record
      Fixed1 : Gtk_Fixed;
      Frame8 : Gtk_Frame;
      Label4 : Gtk_Label;
      Frame5 : Gtk_Frame;
      Name_Label : Gtk_Label;
      Frame4 : Gtk_Frame;
      Start_Bid_Label : Gtk_Label;
      Frame6 : Gtk_Frame;
      Current_Bid_Label : Gtk_Label;
      Frame7 : Gtk_Frame;
      Hbox1 : Gtk_Hbox;
      Bid_Spinbutton : Gtk_Spin_Button;
      Bid_Button : Gtk_Button;
      ----------
      ---  Special bidouille
      Vbox33 : Gtk_Vbox;
      The_Pixmap : Gtk_Pixmap;
      Label33 : Gtk_Label;
      ------------
      -- Pixmaps;
      Question_Pixmap : Gtk_Pixmap;
      Smile_Pixmap : Gtk_Pixmap;
      Warning_Pixmap : Gtk_Pixmap;
      Lock_Pixmap : Gtk_Pixmap;
      Bomb_Pixmap : Gtk_Pixmap;
      Smiley_Pixmap : Gtk_Pixmap;
      Sickface_Pixmap : Gtk_Pixmap;
      Stop_Pixmap : Gtk_Pixmap;
      Smiley3_Pixmap : Gtk_Pixmap;

      User_ID : User_Identifier_Type;
      Auction_ID : Auction_Identifier_Type;
      Auction_State : Bid_Win_Status_Type := Bidding;
      Button_Is_Quit : Boolean := False;

      My_Timeout_Handler_Id : Timeout_Handler_Id;
      --  Bid_Command_Buffer : Command_Buffer_Ref;
      Has_Placed_Bid : Boolean := False;

   end record;
   type Bid_Window_Access is access all Bid_Window_Record'Class;

   procedure Gtk_New (Bid_Window : out Bid_Window_Access;
                      User_Id : User_Identifier_Type;
                      My_Auction_ID :  Auction_Identifier_Type);
   procedure Initialize (Bid_Window : access Bid_Window_Record'Class);
   procedure Cosmetics (Bid_Window : access Bid_Window_Record'Class);

   --  Bid_Window : Bid_Window_Access;

end Bid_Window_Pkg;
