with Gtk.Window; use Gtk.Window;
with Gtk.Fixed; use Gtk.Fixed;
with Gtk.Frame; use Gtk.Frame;
with Gtk.Label; use Gtk.Label;
with Gtk.Button; use Gtk.Button;
with Transactional_Auctions; use Transactional_Auctions;
--  with Command_Buffers; use Command_Buffers;
with Auction_Interface; use Auction_Interface;
with User_Interface; use User_Interface;
with Remote_String_Arrays; use Remote_String_Arrays;
with Gtk.Main; use Gtk.Main;

package Sell_Window_Pkg is

   type Sell_Window_Record is new Gtk_Window_Record with record
      Fixed1 : Gtk_Fixed;
      Frame8 : Gtk_Frame;
      Label4 : Gtk_Label;
      Frame4 : Gtk_Frame;
      Start_Bid_Label : Gtk_Label;
      Frame6 : Gtk_Frame;
      Current_Bid_Label : Gtk_Label;
      Frame7 : Gtk_Frame;
      Accept_Button : Gtk_Button;
      Frame5 : Gtk_Frame;
      Name_Label : Gtk_Label;

      Auction_Id : Auction_Identifier_Type;
      User_Id : User_Identifier_Type;
      My_Timeout_Handler_Id : Timeout_Handler_Id;

  --    Sell_Command_Buffer : Command_Buffer_Ref;
   end record;
   type Sell_Window_Access is access all Sell_Window_Record'Class;

   procedure Gtk_New (Sell_Window : out Sell_Window_Access;
                      User_Id : User_Identifier_Type;
                      Auction_Id : Auction_Identifier_Type);

   procedure Initialize (Sell_Window : access Sell_Window_Record'Class);

   --  Sell_Window : Sell_Window_Access;

end Sell_Window_Pkg;
