with Gtk.Arguments;
with Gtk.Widget; use Gtk.Widget;
with Gtk.Clist; use Gtk.Clist;

package Login_Window_Pkg.Callbacks is

   Users_Visible : Boolean := False;
   Users_List : Gtk_Clist;

   function On_Login_Window_Key_Press_Event
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args) return Boolean;

   procedure On_Login_Window_Destroy
     (Object : access Gtk_Window_Record'Class);

   function On_Login_Window_Delete_Event
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args) return Boolean;

   procedure On_New_User_Button_Pressed
     (Object : access Gtk_Button_Record'Class);

   procedure On_Users_Button_Pressed
     (Object : access Gtk_Button_Record'Class);

   procedure On_Quit_Button_Pressed
     (Object : access Gtk_Button_Record'Class);

   procedure On_Login_Button_Pressed
     (Object : access Gtk_Button_Record'Class);

end Login_Window_Pkg.Callbacks;
