with Gtk.Handlers;
with Gtk.Window; use Gtk.Window;
with Gtk.Widget; use Gtk.Widget;
with Gtk.Button; use Gtk.Button;
with New_User_Window_Pkg; use New_User_Window_Pkg;

package Callbacks_New_User is

   package Window_Callback is new
     Gtk.Handlers.User_Callback (Widget_Type => Gtk_Window_Record,
                                 User_Type => New_User_Window_Access);

   package Window_Return_Callback is new
     Gtk.Handlers.User_Return_Callback (Widget_Type => Gtk_Window_Record,
                                        User_Type => New_User_Window_Access,
                                        Return_Type => Boolean);

   package Button_Callback is new
     Gtk.Handlers.User_Callback (Widget_Type => Gtk_Button_Record,
                                 User_Type => New_User_Window_Access);

   package Widg_Callback is new
     Gtk.Handlers.User_Return_Callback (Widget_Type => Gtk_Widget_Record,
                                        User_Type => New_User_Window_Access,
                                        Return_Type => Boolean);
end Callbacks_New_User;
