with Gtk.Arguments;
with Gtk.Widget; use Gtk.Widget;

package User_Win_Pkg.Callbacks is
   function On_User_Win_Delete_Event
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args) return Boolean;

   procedure On_User_Win_Destroy
     (Object : access Gtk_Window_Record'Class);

   procedure On_Auctions_List_Select_Row
     (Object : access Gtk_Clist_Record'Class;
      Params : Gtk.Arguments.Gtk_Args;
      User_Win : User_Win_Access);

   procedure On_Bid_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      User_Win : User_Win_Access);

   procedure On_Deposit_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      User_Win : User_Win_Access);

   procedure On_New_Auction_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      User_Win : User_Win_Access);

   procedure On_Cancel_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      User_Win : User_Win_Access);

    function  Update_Infos (User_Win : User_Win_Access) return Boolean;

end User_Win_Pkg.Callbacks;
