with User_Interface; use User_Interface;
with Remote_String_Arrays; use Remote_String_Arrays;

package Server_Interface is

   pragma Remote_Call_Interface;

   function Login (Username : String;
                   Password : String) return User_Identifier_Type;

   procedure New_User (Name : String; Password : String);

   Login_Incorrect : exception;

   function Get_Current_Auction_List return Remote_String_Array_Type;


end Server_Interface;

