--  with Auction_Interface; use Auction_Interface;
with Auction_Communication; use Auction_Communication;
with Transactional_Users; use Transactional_Users;
with Transactional_Accounts; use Transactional_Accounts;
with My_Strings; use My_Strings;
with Remote_String_Arrays; use Remote_String_Arrays;

package Seller_Tasks is

   task type Seller_Task_Type (Communication : Auction_Communication_Ref;
                               Title : String_Ref;
                               Description : String_Ref;
                               Initial_Bid : Integer;
                               My_User : Transactional_User_Ref;
                               My_Account : Transactional_Account_Ref;
                               My_Auction_Id : Auction_Identifier_Type);

   type Seller_Task_Ref is access all Seller_Task_Type;

end Seller_Tasks;
