with Ada.Text_IO;
with Procedural_Transaction_Interface; use Procedural_Transaction_Interface;
with Debug; use Debug;

procedure Server_Main is

   C : Character;

begin

   Toggle (Initialization);

   System_Init;
   Ada.Text_IO.Put_Line ("Server started...");
   Ada.Text_IO.New_Line;
   Ada.Text_IO.New_Line;
   Ada.Text_IO.New_Line;

   loop
      New_Line;
      Ada.Text_IO.Put_Line ("Hit the corresponding key to activate debug messages:");
      Ada.Text_IO.Put_Line ("a) All");
      Ada.Text_IO.Put_Line ("e) English Auction");
      Ada.Text_IO.Put_Line ("r) Recovery");
      Ada.Text_IO.Put_Line ("i) Important info");
      Ada.Text_IO.Put_Line ("u) User tasks");
      Ada.Text_IO.Get_Immediate (C);
      Ada.Text_IO.New_Line;
      case C is
         when 'q' =>
            exit;
         when 'a' =>
            Debug.Toggle;
         when 'r' =>
            Debug.Toggle (Initialization);
         when 'e' =>
            Debug.Toggle (Auction);
         when 'i' =>
            Debug.Toggle (Important);
         when 'u' =>
            Debug.Toggle (User);
         when others =>
            null;
      end case;
      Ada.Text_IO.New_Line;
      Ada.Text_IO.New_Line;
      Ada.Text_IO.New_Line;
      Ada.Text_IO.New_Line;
      Ada.Text_IO.New_Line;
   end loop;

   System_Shutdown;

end Server_Main;
